function foxfm_stadium(document)
{
	try 
	{
		var addOverallPrices	= prefBranchOFMFunctionSettings.get("stadium.addOverallPrices");
		var addOffsetPrices		= prefBranchOFMFunctionSettings.get("stadium.addOffsetPrices");

		if(document.location.href.match("010_stadion/stadion.php") && addOverallPrices) 
		{
			infoMessage(2, "foxfm_stadium(): start");

			var allTables					= document.getElementsByTagName("table");
			
			// add overall price table
			var searchStringStadiumTable	= /Stadionname\s*\S*ndern/;
			var overallPricingTable = createPricingTable(document, "overall", 1, 69,
								"Allg. Liga Eintrittspreis", "<font color=\"black\">Liga:</font>",
								"Allg. Freundschaftsspiel Eintrittspreis", "<font color=\"black\">Freundschaftsspiel:</font>",
								"Allg. OFM-Pokal Eintrittspreis", "<font color=\"black\">OFM-Pokal:</font>");
								
			// find table where to put the pricing table
			var blockTableNo		= getTableNumber(document, searchStringStadiumTable);
			var blockTableCol		= getColumnNumber(document, searchStringStadiumTable);
			var blockTableRow		= getRowNumber(document, searchStringStadiumTable);
			infoMessage(3, "foxfm_stadium(): table(" + searchStringStadiumTable + "):" + blockTableNo + ", " + blockTableCol + ", " + blockTableRow);

			allTables[blockTableNo].rows[blockTableRow].insertCell(blockTableCol);				
			allTables[blockTableNo].rows[blockTableRow].cells[blockTableCol].appendChild(overallPricingTable);

			// add offset price table if activated
			if(addOffsetPrices)
			{
				var arrayTribune = new Array (/Nord-Trib\S*ne/, /Ost-Trib\S*ne/, /S\S*d-Trib\S*ne/, /West-Trib\S*ne/);
				for(var i=0; i<arrayTribune.length; i++)
				{
					var blockNumber = i + 1;
					var pricingTable = createPricingTable(document, "block" + blockNumber +"Offset", 0, 69,
										"Aufschlag zum allg. Liga Eintrittspreis", null,
										"Aufschlag zum allg. Freundschaftsspiel Eintrittspreis", null,
										"Aufschlag zum allg. OFM-Pokal Eintrittspreis", null);
										
					// find table where to put the pricing table
					var tribune				= arrayTribune[i];
					var blockTableNo		= getTableNumber(document, tribune);
					var blockTableCol		= getColumnNumber(document, tribune);
					var blockTableRow		= getRowNumber(document, tribune);

					var lastRow		= allTables[blockTableNo].rows.length - 1;
					var lastCell	= allTables[blockTableNo].rows[lastRow].insertCell(-1);
					var header		= createElement(document, "B", null, null, "minitext dsR42", null, null, null);
					lastCell.appendChild(header);
					var headerText	= document.createTextNode("Aufschlag");
					header.appendChild(headerText);
				
					lastCell.appendChild(pricingTable);		
								
					// enlarge colspan of row containing name of tribune
					allTables[blockTableNo].rows[blockTableRow].cells[blockTableCol].setAttribute("colspan", 6);
				}
									
				// change width of table containing stadium - find by attribute 'bgcolor' using XPath
				var result = document.evaluate( '//.[@bgcolor="#b8df8f"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
				infoMessage(2, "Number of stadium tables: " + result.snapshotLength);
				if(result.snapshotLength == 1)
				{
					result.snapshotItem(0).width = "806";
				}				
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

/*******************************************************************************
 * Name of function:		createPricingTable()
 * Arguments of function:	document
 * Description of function:	This function creates a new table with three rows
 *							containing each a dropdown. An event handler is 
 *							attached to each dropdown.
 */
function createPricingTable(document, block, ddMinPrice, ddMaxPrice,
							ddTooltipPriceLeague,	ddLabelPriceLeague,
							ddTooltipPriceFriendly,	ddLabelPriceFriendly,
							ddTooltipPriceCup,		ddLabelPriceCup
							)
{
	try
	{
		// get default price preferences
		var strPrefPriceLeague	= "stadium." + block + "PriceLeague";
		var strPrefPriceFriendly= "stadium." + block + "PriceFriendly";
		var strPrefPriceCup		= "stadium." + block + "PriceCup";

		var ddPrefPriceLeague	= prefBranchOFMFunctionSettings.get(strPrefPriceLeague);
		var ddPrefPriceFriendly	= prefBranchOFMFunctionSettings.get(strPrefPriceFriendly);
		var ddPrefPriceCup		= prefBranchOFMFunctionSettings.get(strPrefPriceCup);
		
		var newRowPriceLeague	= createRowStadiumPrice(document, "ddIdPriceLeague" + block		, ddMinPrice, ddMaxPrice, ddTooltipPriceLeague,		null, ddPrefPriceLeague,	ddLabelPriceLeague);		
		var newRowPriceFriendly	= createRowStadiumPrice(document, "ddIdPriceFriendly" + block	, ddMinPrice, ddMaxPrice, ddTooltipPriceFriendly,	null, ddPrefPriceFriendly,	ddLabelPriceFriendly);
		var newRowPriceCup		= createRowStadiumPrice(document, "ddIdPriceCup" + block		, ddMinPrice, ddMaxPrice, ddTooltipPriceCup,		null, ddPrefPriceCup,		ddLabelPriceCup);
		
		// attache event handler
		var ofmStadiumMinPrice = 0;
		var ofmStadiumMaxPrice = 68;
		newRowPriceLeague.addEventListener(		"change", function(event){eventStadiumPricing(event, strPrefPriceLeague,	ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);			
		newRowPriceFriendly.addEventListener(	"change", function(event){eventStadiumPricing(event, strPrefPriceFriendly,	ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		newRowPriceCup.addEventListener(		"change", function(event){eventStadiumPricing(event, strPrefPriceCup,		ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		
		newRowPriceLeague.addEventListener(		"keyup", function(event){eventStadiumPricing(event, strPrefPriceLeague,		ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);			
		newRowPriceFriendly.addEventListener(	"keyup", function(event){eventStadiumPricing(event, strPrefPriceFriendly,	ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		newRowPriceCup.addEventListener(		"keyup", function(event){eventStadiumPricing(event, strPrefPriceCup,		ofmStadiumMinPrice, ofmStadiumMaxPrice)}, false);
		
		// create pricing table
		var pricingTable 		= createTable(document, "dsR1", 0, 1);
				
		pricingTable.appendChild(newRowPriceLeague);
		pricingTable.appendChild(newRowPriceFriendly);
		pricingTable.appendChild(newRowPriceCup);
			
		return pricingTable;
	} catch (e) {
		errorMessage(e);
	}
}

function eventStadiumPricing(event, pref, minPrice, maxPrice)
{
	try
	{
		var document			= event.originalTarget.ownerDocument;
		var eventTargetNode 	= event.target;
		var eventType 			= event.type;
		var eventTargetId		= event.target.id;
		var eventKeycode		= event.keyCode;
		var newPrice=0, offsetPrice=0;

		infoMessage(3, "eventStadiumPricing(): started: " + eventType + "; pref: " + pref);

		// run this handler only on mouse or arrow keys (keyocde: 37-40) events
		if(!eventKeycode || (eventKeycode>=37 && eventKeycode<=40))
		{
			infoMessage(3, "eventStadiumPricing(): event type: " + eventType + "; node name: " + eventTargetNode.nodeName + "; key code: " + eventKeycode);
			
			// get type of game (L, F, C) and number of block
			var gameType			= getTypeOfGame(eventTargetId);
			var blockOfStadium		= getStadiumBlock(eventTargetId);
			
			// get overall ticket price
			var overallPrice		= document.getElementById("ddIdPrice" + gameType + "overall").selectedIndex;		

			infoMessage(3, "eventStadiumPricing(): " + gameType + " Block " + blockOfStadium);			

			if(blockOfStadium)
			{
				/* handle changes of the offset price */
				offsetPrice = getStadiumOffsetStadiumPriceOfBlock(document, gameType, blockOfStadium);
				newPrice	= coerce(minPrice, maxPrice, overallPrice + offsetPrice);
				setStadiumPriceOfBlock(document, gameType, blockOfStadium, newPrice);
				prefBranchOFMFunctionSettings.set(pref, offsetPrice.toString());
			} else {
				/* handle changes of the overall price */
				for(var i=1; i<5; i++)
				{
					offsetPrice = getStadiumOffsetStadiumPriceOfBlock(document, gameType, i);
					newPrice	= coerce(minPrice, maxPrice, overallPrice + offsetPrice);
					setStadiumPriceOfBlock(document, gameType, i, newPrice);
					prefBranchOFMFunctionSettings.set(pref, overallPrice.toString());
				}
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

function getStadiumOffsetStadiumPriceOfBlock(document, gameType, block)
{
	try
	{
		var offsetPrice		= 0;
		var idOfOffsetPrice	= "ddIdPrice" + gameType + "block" + block + "Offset";
		
		if(document.getElementById(idOfOffsetPrice))
		{
			offsetPrice	= document.getElementById(idOfOffsetPrice).selectedIndex;
		} else {
			offsetPrice = 0;
		}
		
		infoMessage(4, "getStadiumOffsetStadiumPriceOfBlock(): gameType: " + gameType + ", block: " + block + ", offsetPrice: " + offsetPrice);
		
		return offsetPrice;
	} catch (e) {
		errorMessage(e);
	}
}

function setStadiumPriceOfBlock(document, gameType, block, price)
{
	try
	{
		switch (gameType) 
		{
			case "League":
				newBlockCore = "block" + block;
				break;
			case "Friendly":
				newBlockCore = "block" + block + "fr";
				break;
			case "Cup":
				newBlockCore = "block" + block + "pok";
				break;
		}
		document.getElementsByName(newBlockCore)[0].options[price].selected = true;
	} catch (e) {
		errorMessage(e);
	}
}

function createDropDownPrice(document, dropdownId, dropdownRangeMin, dropdownRangeMax, dropdownTooltip, dropdownOnchange, dropdownDefault)
{
	try
	{
		infoMessage(3, "createDropDownPrice(): started");

		var newSelect = createDropdown(document, dropdownId, null, "forminput_60px", "{width:50px;}", dropdownTooltip, dropdownOnchange);
		for(var i=dropdownRangeMin;i<=dropdownRangeMax;i++)
		{
			var newOption	= document.createElement('option');
			newOption.text	= i + " \u20ac";
			newOption.id	= dropdownId + "_" + i;
			newSelect.add(newOption, null);
		}
		if(dropdownDefault<dropdownRangeMax)
		{
			newSelect.options[dropdownDefault].defaultSelected = true;
		}
		return newSelect;
	} catch (e) {
		errorMessage(e);
	}
}

function createRowStadiumPrice(document, selectId, selectMin, selectMax, selectTooltip, selectOnchange, selectDefault, label)
{
	try
	{
		infoMessage(3, "createRowStadiumPrice(): started");
		
		var newRow 				= createRow(document, null, null);
		var newCellLabel 		= createCell(document, null, null, null, label, null, "minitext");
		var newCellDropdown 	= createCell(document, null, null, null, null, null, null);
		var newSelect 			= createDropDownPrice(document, selectId, selectMin, selectMax, selectTooltip, selectOnchange, selectDefault);
		var newInput			= createElement(document, "input", "hidden" + selectId, null, null, null, null, null);
		newInput.setAttribute("type", "hidden");
		
		newCellDropdown.appendChild(newSelect);
		newCellDropdown.appendChild(newInput);

		newRow.appendChild(newCellLabel);
		newRow.appendChild(newCellDropdown);
		
		return newRow;
	} catch (e) {
		errorMessage(e);
	}
}
